function x = Bisezione(f,a,b,N)
    //
    // Applica il metodo di bisezione alla funzione f a partire dall'intervallo [a,b].
    // La costruzione si arresta dopo N iterazioni.
    //
    // La variabile di uscita x contiene la parte di successione calcolata.
    //
    if f(a)*f(b) > 0 then
       error('la funzione non assume valori di segno opposto agli estremi');
    else
        x = (a+b)/2;
        k = 0;
        while (k < N & f(x($)) ~= 0),
            if sign(f(a)) ~= sign(f(x($))) then b = x($);
               else a = x($); end;
            x($+1) = (a+b)/2;
            k = k + 1;
        end;
    end;
endfunction
//
function y = f(x)
    if x > 0 then
       y = x + log(x);
    else disp(x); error('*** argomento non positivo in f! ***')
    end
endfunction
//
N = 20;
//
zB = Bisezione(f,1/2,1,N);
//
clf(); plot2d('nl', [0:N]', [abs(z2 - a),abs(z3 - a),abs(zB - a)], style = [2,5,1]);
xgrid(); xlabel('k'); legend('| z2(k) - a |', '| z3(k) - a |', '| zB(k) - a |');
